<?php
// Sécurité et récupération des données de configuration
define('OK',1);
include('debut.php');
$p = 'connect';

// Titre : on récupère celui de la première page
$mysqli = premiere_connexion();
$resultat = $mysqli->query('SELECT titre FROM pages WHERE id = 1');
$r = $resultat->fetch_assoc();
$resultat->free();
$t = "${r['titre']}";

// Oubli d'identifiant/mot de passe -- copie dans /admin/login.php
if ( isset($_REQUEST['oubli']) )  {

  // Fonctions de connexion/enregistrement
  include('admin/fonctions.php');

  // Traitement du formulaire
  if ( isset($_REQUEST['mail']) && strlen($_REQUEST['mail']) )  {
    // Recherche du mail dans la base de données
    $resultat = $mysqli->query('SELECT id, login, mail FROM utilisateurs');
    while ( $r = $resultat->fetch_assoc() )
      if ( $r['mail'] == $_REQUEST['mail'] )  {
        $utilisateur = $r;
        break;
      }
    $resultat->free();
    if ( isset($utilisateur) )  {
      // Connexion à la base de données avec les droits d'écriture
      $mysqli->close();
      $mysqli = mysql_ecriture();
      // Réinitialisation du mot de passe
      $lettres = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789?./,;:!";
      $mdp = '';
      for ( $i = 0; $i < 8; $i++ )
        $mdp .= substr($lettres,mt_rand(0,68),1);
      requete('utilisateurs','UPDATE utilisateurs SET genre = MOD(genre,5)+5, mdp = \''.sha1($mdp)."' WHERE id = ${utilisateur['id']}");
      // Envoi du mail
      mail($utilisateur['mail'],'[Cahier de Prépa] Modification de votre mot de passe',
"Bonjour

Vous avez demandé à modifier votre mot de passe, correspondant à l'identifiant ${utilisateur['login']}. Ce mot de passe a donc été temporairement réinitialisé à la valeur \"$mdp\". Vous devez vous connecter avec ce mot de passe et le modifier immédiatement ensuite : ce mot de passe est à usage unique et sera automatiquement effacé après votre prochaine connexion.

Cordialement,
-- 
Cahier de Prépa
","From: ne-pas-repondre@cahier-de-prepa.fr\r\nContent-type: text/plain; charset=UTF-8");
      $message = 'Le mot de passe a été réinitialisé et un mail a été envoyé.';
    }
    else
      $message = 'Le mail fourni n\'est pas dans la base de données.';
  }

  // Formulaire de récupération du mail si mdp non déjà réinitialisé
  if ( !isset($utilisateur) )  {
    $t .= ' - Oubli du mot de passe';
    include('haut.php');
    $mysqli->close();
?>
<form class="warning" action="connect" method="post">
  <p>Un mail contenant l'identifiant et un nouveau mot de passe temporaire sera envoyé par mail à l'adresse ci-dessous si elle est bien enregistrée&nbsp;:</p>
  <p class="ligne"><label for="mail">Adresse mail&nbsp;: </label><input type="text" name="mail" id="mail"></p>
  <p><input type="submit" name="Ok" value="Envoyer"></p>
  <input type="hidden" name="oubli" value="1">
</form>
<?php
    include('bas.php');
    exit();
  }
}

// Création de compte
elseif ( isset($_REQUEST['creation']) )  {

  // Fonctions de connexion/enregistrement
  include('admin/fonctions.php');

  // Traitement du formulaire
  if ( isset($_REQUEST['valide']) )  {
    // Validation des données envoyées
    $genre = ( in_array($_REQUEST['genre'],array(1,2,3)) ) ? $_REQUEST['genre'] : 0;
    $prenom = mb_convert_case(strip_tags($mysqli->real_escape_string($_REQUEST['prenom'])),MB_CASE_TITLE,'UTF-8');
    $nom = mb_convert_case(strip_tags($mysqli->real_escape_string($_REQUEST['nom'])),MB_CASE_TITLE,'UTF-8');
    $mail = strtolower($mysqli->real_escape_string($_REQUEST['mail']));
    $mdp1 = sha1($_REQUEST['mdp1']);
    // Si "colleur" choisi, autorisation vaut 3. Sinon, 2 (élève)
    if ( $_REQUEST['autorisation'] == 2 )  {
      $autor = 3;
      $matiere = ( isset($_REQUEST['matiere']) && is_numeric($_REQUEST['matiere']) ) ? $_REQUEST['matiere'] : '';
      $mailexp = $mailcopy = 1;
    }
    else  {
      $autor = 2;
      $matiere = '';
      $mailexp = $mailcopy = 0;
    }
    // Login temporaire : connexion impossible tant que le compte n'est pas validé
    // À la validation, les 8 premiers caractères seront supprimés
    $login = 'tmp'.mt_rand(10000,99999).mb_strtolower(mb_substr($prenom,0,1,'UTF-8').str_replace(' ','_',$nom),'UTF-8');
    // Écriture dans la base de données'
    if ( $mdp1 != sha1($_REQUEST['mdp2']) )
      $message = 'Les mots de passe donnés ne sont pas identiques.';
    elseif ( strlen($mail) && !filter_var($mail,FILTER_VALIDATE_EMAIL) )
      $message = 'L\'adresse mail est incorrecte.';
    elseif ( strlen($prenom) && strlen($nom) && strlen($mdp1) )  {
      // Connexion à la base de données avec les droits d'écriture
      $mysqli->close();
      $mysqli = mysql_ecriture();
      if ( requete('utilisateurs',"INSERT INTO utilisateurs SET login = '$login', genre = $genre, prenom = '$prenom', nom = '$nom',
                                   mail = '$mail', mdp = '$mdp1', autorisation = $autor, matieres = '$matiere', timeout = 900, mailexp = $mailexp, mailcopy = $mailcopy") )
        $message = "La demande de création a bien été enregistrée. Vous recevrez un mail dès qu'elle aura été traitée par l'équipe pédagogique.";
      $mysqli->close();
      $mysqli = mysql_lecture();
    }
  }
  
  // Affichage du formulaire de demande
  $t .= ' - Création de compte';
  include('haut.php');
  
  // Récupération des matières
  $resultat = $mysqli->query('SELECT id, nom FROM matieres');
  $select_matieres = '';
  while ( $r = $resultat->fetch_assoc() )
    $select_matieres .= "        <option value=\"${r['id']}\">${r['nom']}</option>\n";
  $mysqli->close();  
?>
  <div class="item admin">
  <form action="" method="post">
    <input class="bouton" type="submit" name="valide" value="Valider" title="Valider les modifications">
    <h3>Demander une création de compte</h3>
    <p class="ligne"><label for="genre">M&nbsp;/&nbsp;Mme&nbsp;/&nbsp;Melle&nbsp;:</label>
      <select name="genre" id="genre">
        <option value="1">M.</option>
        <option value="2">Mme</option>
        <option value="3">Melle</option>
      </select>
    </p>
    <p class="ligne"><label for="prenom">Prénom&nbsp;: </label><input type="text" id="prenom" name="prenom" value="" size="50"></p>
    <p class="ligne"><label for="nom">Nom&nbsp;: </label><input type="text" id="nom" name="nom" value="" size="50"></p>
    <p class="ligne"><label for="mail">Adresse mail&nbsp;: </label><input type="text" id="mail" name="mail" value="" size="50"></p>
    <p class="ligne"><label for="mdp1">Mot de passe&nbsp;: </label><input type="password" id="mdp1" name="mdp1" value=""></p>
    <p class="ligne"><label for="mdp2">Confirmation&nbsp;: </label><input type="password" id="mdp2" name="mdp2" value=""></p>
    <p class="ligne"><label for="autorisation">Élève ou colleur&nbsp;:</label>
      <select name="autorisation" id="autorisation">
        <option value="1">Élève</option>
        <option value="2">Colleur</option>
      </select>
    </p>
    <p class="ligne"><label for="matiere">Matière&nbsp;:</label>
      <select name="matiere" id="matiere">
<?php echo $select_matieres; ?>
      </select>
    </p>
    <p>Une fois complétée, cette demande sera envoyée pour approbation à l'équipe pédagogique. La validation de votre demande sera faite manuellement et ne sera donc sûrement pas immédiate. Vous recevrez une confirmation par mail une fois cette validation réalisée.</p>
    <p>L'adresse mail servira uniquement à l'envoi des mails par l'équipe pédagogique ou à la récupération d'un nouveau mot de passe en cas d'oubli. Renseignez une adresse que vous consultez fréquemment.</p>
    <p>Le mot de passe vous est complètement personnel et ne sera divulgué à personne. Il est chiffré avant son stockage dans la base de données.</p>
  </form>
  </div>

  <script type="text/javascript">
$( function() {
  $('#autorisation').change( function() { 
    switch ( $(this).val() )  {
      case '1' : $('#matiere').parent().hide(); break;
      case '2' : $('#matiere').parent().show(); break;
    }
  });
  $('#matiere').parent().hide();
});
  </script>

<?php
  include('bas.php');
  exit();
}

// Gestion de la connexion
$t .= ' - Connexion';
include('login.php');

// On n'arrive ici que si la connexion est établie : accès à l'espace utilisateur
header("Location: https://$site/prefs");
?>
